# Client_Pre_Command_Handler is called when an action is received from
# a FOP2 Client (from the browser), like changing the presence, initiating
# a transfer, etc. You also can return an AMI command to be sent. 
# The Pre handler will issue your commands BEFORE the standard FOP2
# response. The Post handler will issue the commands AFTER the standard
# FOP2 response.
#
# The first key is the name of the plugin, the second the action received
# from a FOP2 client. You can catch here custom actions defined in the .js
# part of a plugin too.
#
# A good way to see the commands that can be recieved from the client is
# to start fop2_server in debug level 4: /usr/local/fop2/fop2_server -X 4
#
$Client_Post_Command_Handler{'loginstateupdate'}{'auth'} = sub {

    my $url = defined($main::pluginconfig{'loginstateupdate'}{'url_on_login'}{''})?$main::pluginconfig{'loginstateupdate'}{'url_on_login'}{''}:'';

    my $origen     = shift;
    my $destino    = shift;
    my $contexto   = shift;
    my $socket     = shift;
    my $logsuccess = shift;
    my $ip_port    = shift;

    if($logsuccess==1) {
        my ($onlyip,$onlyport) =~ split/:/, $ip_port;

        $url =~ s/#{EXTEN}/$destino/g;
        $url =~ s/#{IP}/$onlyip/g;
        $url =~ s/#{PORT}/$onlyport/g;

        $url =~ s/\&/\\&/g;
        $url =~ s/\!/\\!/g;

        print "login origen $origen destino $destino ctx $contexto ip $ip_port url $url\n";
       
        system("/usr/bin/wget --no-check-certificate -qO- $url &> /dev/null &");

        my @allreturn = ();
        return @allreturn;
    }
};

$Client_Post_Command_Handler{'loginstateupdate'}{'logoff'} = sub {
    my $origen     = shift;
    my $destino    = shift;
    my $contexto   = shift;
    my $socket     = shift;
    my $extension  = shift;
    my $url = defined($main::pluginconfig{'loginstateupdate'}{'url_on_logout'}{''})?$main::pluginconfig{'loginstateupdate'}{'url_on_logout'}{''}:'';

    $url =~ s/#{EXTEN}/$destino/g;
    $url =~ s/#{IP}/$onlyip/g;
    $url =~ s/#{PORT}/$onlyport/g;

    $url =~ s/\&/\\&/g;
    $url =~ s/\!/\\!/g;

    print "logoff origen $origen destino $destino context $contexto socket $socket extension $extension\n";

    system("/usr/bin/wget --no-check-certificate -qO- $url &> /dev/null &");

    my @allreturn = ();
    return @allreturn;
};

$Client_Pre_Command_Handler{'loginstateupdate'}{'setastdb'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $return   = '';
    my ($key,$exten,$data) = split(/~/,$destino);
    my $url = defined($main::pluginconfig{'loginstateupdate'}{'url_on_presence'}{''})?$main::pluginconfig{'loginstateupdate'}{'url_on_presence'}{''}:'';

    $data =~ s/ /%20/g;

    $url =~ s/#{EXTEN}/$exten/g;
    $url =~ s/#{IP}/$onlyip/g;
    $url =~ s/#{PORT}/$onlyport/g;
    $url =~ s/#{STATE}/$data/g;

    $url =~ s/\&/\\&/g;
    $url =~ s/\!/\\!/g;

    print "setastdb $exten $data ($destino) ($url)\n";

    if($key eq "fop2state") {
        system("/usr/bin/wget --no-check-certificate -qO- $url &> /dev/null &");
    }
    my @allreturn = ();
    return @allreturn;
}
 
